Subject: Re: TCP partial write

From: Rick Jones <[email-masked]>
Date: Mon, 15 Jun 2009 10:09:29 -0700

Paul Martin wrote:
> Is it possible that a (non-blocking) TCP write(2) will write a number
> of bytes not multiple of the machine word size? i.e., could a write
> request for 4 bytes return 2?

Yes.

> Also is this an OS-dependent behavior or there is a spec for it? (I
> could find atomic guarantees for pipes and datagram sockets but not
> for TCP)

TCP is a byte-stream. It sends and receives a stream of bytes.  You should/must 
assume that when you do a non-blocking write, it will take any number of the 
bytes you offer from 0 to however many bytes you give it.  And you should/must 
assume that at the other end, your recv/read calls will return with between 0 and 
however many bytes you ask of them, with 0 meaning the remote has said it has 
nothing left to give.

rick jones